deferred class
	AST_NODE

inherit
	DEFAULT_HASHABLE
	ANTLR_TRANSFORMATION_UTILITIES

feature {ANY} -- AST

	parent: AST_NODE assign set_parent

	parent_of_type (a_type: TYPE [ANY]): AST_NODE
		require
			a_type /= Void
		local
			l_cur: AST_NODE
		do
			from
				l_cur := Current
			until
				l_cur = Void or Result /= Void
			loop
				if a_type #? l_cur /= Void then
					Result := l_cur
				end
				l_cur := l_cur.parent
			end
		end

	accept (v: AST_VISITOR)
		deferred
		end

	ast_twin: like Current
		deferred
		end

	make_copy (other: like Current)
		deferred
		end

feature {ANY} -- utilities

	c_code: STRING
		local
			v: AST_C_CREATOR
		do
			create v.make
			accept (v)
			Result := v.buffer
		end

	eiffel_code: STRING
		local
			v: AST_EIFFEL_CREATOR
		do
			create v.make
			accept (v)
			Result := v.buffer
		end

feature {AST_NODE}

	set_parent (init_parent: AST_NODE)
		do
			parent := init_parent
		ensure
			parent_set: parent = init_parent
		end

	visit_node (node: AST_NODE; v: AST_VISITOR)
		require
			visitor_exists: v /= Void
		do
			if node /= Void then
				node.accept (v)
			end
		end

	visit_list (list: LIST [AST_NODE]; v: AST_VISITOR)
		require
			visitor_exists: v /= Void
		do
			if list /= Void then
				across list.twin as c loop
					if c.item /= Void then
						c.item.accept (v)
					end
				end
			end
		end

end
