class
	AST_BITFIELD

inherit
	AST_STRUCT_FIELD
		redefine
			make_copy
		end

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_bitfield
		do
			parent := init_parent

			node.children.start
			type := process_type (node.children.item, Current)
			node.children.forth
			if node.children.item.type /= Ast_decimal_constant then
				identifier := node.children.item.token_text
				orig_c_identifier := identifier.twin
				node.children.forth
			end
			size := create {AST_DECIMAL_CONSTANT}.make_from_antlr (node.children.item, Current)
			node.children.forth
			if not node.children.after then
				create gcc_attribute_specifier.make_from_antlr (node.children.item, Current)
			end
		end

feature {ANY}

	type: AST_TYPE

	identifier: STRING

	size: AST_DECIMAL_CONSTANT

	orig_c_identifier: STRING

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_bit_field (Current)
			if visit_children then
				visit_node (type, v)
				visit_node (size, v)
			end
			v.end_visit_bit_field (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (a_other: like Current)
		do
			Precursor (a_other)
			type := a_other.type.ast_twin
			if a_other.identifier /= Void then
				identifier := a_other.identifier.twin
			end
			orig_c_identifier := a_other.orig_c_identifier -- won't be changed
			size := a_other.size.ast_twin
		end

invariant
	attached {AST_BASIC_TYPE} type or attached {AST_TYPEDEF_TYPE} type or attached {AST_ENUM_TYPE} type
	size /= Void

end
