class
	AST_INITIALIZER

inherit
	AST_EXPRESSION

create
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_elements: ARRAY [AST_EXPRESSION]; a_type_binding: AST_TYPE)
		require
			a_elements /= Void
			across a_elements as c all c.item /= Void and then c.item.parent = Void end
			a_type_binding /= Void
		do
			elements := create {TWO_WAY_LIST [AST_EXPRESSION]}.make
			across a_elements as c loop
				elements.extend (c.item)
				c.item.parent := Current
			end
			type_binding := a_type_binding
		end

	make_from_antlr (node: ANTLR_AST_NODE; a_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_array_initializer
		do
			parent := a_parent

			elements := create {TWO_WAY_LIST [AST_EXPRESSION]}.make
			across node.children as c loop
				elements.extend (process_expression (c.item, Current))
			end
		end

feature {ANY}

	elements: LIST [AST_EXPRESSION]

	type_binding: AST_TYPE assign set_type_binding

	set_type_binding (a_type_binding: AST_TYPE)
		do
			type_binding := a_type_binding
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_initializer (Current)
			if visit_children then
				visit_list (elements, v)
			end
			v.end_visit_initializer (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			elements := create {TWO_WAY_LIST [AST_EXPRESSION]}.make
			across other.elements as c loop
				elements.extend (c.item.ast_twin)
				elements.last.parent := Current
			end
			type_binding := other.type_binding
		end

invariant
	elements /= Void

end
