class
	AST_EIFFEL_JUMP_TARGET

inherit
	AST_STATEMENT

create
	make,
	make_comment,
	make_copy

feature {NONE}

	make (a_index: NATURAL)
		do
			create index
			index.set_item (a_index)
		ensure
			index.item = a_index
		end

	make_comment (a_index: NATURAL; a_comment: STRING)
		require
			a_comment /= Void
		do
			make (a_index)
			comment := a_comment
		ensure
			index.item = a_index
			comment = a_comment
		end

feature {ANY}

	index: NATURAL_32_REF

	comment: STRING_8

	append_comment (a_comment: STRING_8)
		require
			a_comment /= Void
		do
			if comment = Void then
				comment := a_comment
			else
				comment.append (" | ")
				comment.append (a_comment)
			end
		end

feature {ANY}

	indent_update: INTEGER assign set_indent_update

	set_indent_update (a_indent_update: INTEGER)
		do
			indent_update := a_indent_update
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_eiffel_jump_target (Current)
			if visit_children then
				-- no children...
			end
			v.end_visit_eiffel_jump_target (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			index := other.index
			if other.comment /= Void then
				comment := other.comment.twin
			end
		end

invariant
	index /= Void

end
