class
	AST_WHILE_STATEMENT

inherit
	AST_STATEMENT

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_while_statement
		do
			parent := init_parent
			condition := process_expression (node.children.i_th (3), Current)
			create statements.make_from_antlr (node.children.i_th (5), Current)
		end

feature {ANY}

	condition: AST_EXPRESSION

	statements: AST_COMPOUND_STATEMENT

feature {ANY} -- C2Eif data

	requires_split: BOOLEAN assign set_requires_split

	set_requires_split (a_requires_split: BOOLEAN)
		do
			requires_split := a_requires_split
		end

	has_continue_statements: BOOLEAN assign set_has_continue_statements
			-- if the loop has continue statements

	set_has_continue_statements (a_has_continue_statements: BOOLEAN)
		do
			has_continue_statements := a_has_continue_statements
		end

	has_return_statements: BOOLEAN assign set_has_return_statements
			-- if the loop has return statements

	set_has_return_statements (a_has_return_statements: BOOLEAN)
		do
			has_return_statements := a_has_return_statements
		end

	has_break_statements: BOOLEAN assign set_has_break_statements
			-- if the loop has break statements

	set_has_break_statements (a_has_break_statements: BOOLEAN)
		do
			has_break_statements := a_has_break_statements
		end

	has_continue_label: BOOLEAN assign set_has_continue_label

	set_has_continue_label (a_has_continue_label: BOOLEAN)
		do
			has_continue_label := a_has_continue_label
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_while_statement (Current)
			if visit_children then
				visit_node (condition, v)
				visit_node (statements, v)
			end
			v.end_visit_while_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			condition := other.condition.ast_twin
			condition.parent := Current
			statements := other.statements.ast_twin
			statements.parent := Current
			requires_split := other.requires_split

			has_continue_statements := other.has_continue_statements
			has_return_statements := other.has_return_statements
			has_break_statements := other.has_break_statements
			has_continue_label := other.has_continue_label
		end

invariant
	condition /= Void
	statements /= Void

end
