class
	AST_FUNCTION_TYPE

inherit
	AST_TYPE
		redefine
			make_copy
		end

create
	make,
	make_copy

feature {NONE}

	make (a_return_type: AST_TYPE; a_parameter_list: AST_PARAMETER_LIST)
		require
			a_return_type /= Void and then a_return_type.parent = Void
			a_parameter_list /= Void implies a_parameter_list.parent = Void
		do
			a_return_type.parent := Current
			return_type := a_return_type
			if a_parameter_list /= Void then
				a_parameter_list.parent := Current
				parameter_list := a_parameter_list
			else
				create parameter_list.make
				parameter_list.parent := Current
			end
		end

feature {ANY}

	return_type: AST_TYPE

	parameter_list: AST_PARAMETER_LIST

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_function_type (Current)
			if visit_children then
				visit_node (return_type, v)
				visit_node (parameter_list, v)
			end
			v.end_visit_function_type (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			Precursor (other)
			return_type := other.return_type.ast_twin
			return_type.parent := Current
			parameter_list := other.parameter_list.ast_twin
			parameter_list.parent := Current
		end

feature {ANY} -- AST_TYPE

	is_equal_type (a_type: AST_TYPE): BOOLEAN
		local
--			params1, params2: LIST [AST_NODE]
--			type1, type2: AST_TYPE
		do
			if attached {AST_FUNCTION_TYPE} a_type as other_type then
				Result := True -- untyped in the Eiffel output
--				params1 := parameter_list.parameters
--				params2 := other_type.parameter_list.parameters
--				Result := return_type.is_equal_type (other_type.return_type) and
--					params1.count = params2.count and
--					parameter_list.is_vararg = other_type.parameter_list.is_vararg
--				if Result then
--					from
--						params1.start
--						params2.start
--					until
--						not Result or params1.after
--					loop
--						if attached {AST_VARIABLE_DECLARATION} params1.item as tmp then
--							type1 := tmp.type
--						elseif attached {AST_TYPE} params1.item as tmp then
--							type1 := tmp
--						end
--						if attached {AST_VARIABLE_DECLARATION} params2.item as tmp then
--							type2 := tmp.type
--						elseif attached {AST_TYPE} params2.item as tmp then
--							type2 := tmp
--						end
--						Result := type1.is_equal_type (type2)
--						params1.forth
--						params2.forth
--					end
--				end
			end
		end


invariant
	return_type /= Void
	parameter_list /= Void
	parent /= Void implies (attached {AST_POINTER_TYPE} parent or attached {AST_TYPEDEF_DECLARATION} parent)

end
