class
	AST_TREE_PRINTER

inherit
	AST_DEFAULT_VISITOR
		redefine
			pre_visit,
			post_visit
		end

create
	make

feature {NONE}

	tree: EV_TREE
	item_stack: STACK [EV_TREE_ITEM]

	make (a_tree: EV_TREE)
		do
			tree := a_tree
			item_stack := create {LINKED_STACK [EV_TREE_ITEM]}.make
		end

feature {ANY}

	pre_visit (node: AST_NODE)
		local
			item: EV_TREE_ITEM
		do
			create item.make_with_text (node.generator)
			item.set_data (node)
			if item_stack.is_empty then
				tree.extend (item)
			else
				item_stack.item.extend (item)
			end
			item_stack.extend (item)
		end

	post_visit (node: AST_NODE)
		do
			item_stack.remove
		end

end
