class
	C2EIFFEL_WINDOW

inherit
	EV_TITLED_WINDOW
		redefine
			initialize
		end
	VIEW_INTERFACE
		undefine
			default_create,
			copy
		end

create
	make

feature {NONE} -- data

	file_field, dir_field, libraries_field, include_dirs_field: EV_TEXT_FIELD
	fileopen_button, diropen_button: EV_BUTTON
	disable_oo_structs_button, disable_oo_reengineering_button, disable_bounds_checking_button: EV_CHECK_BUTTON
	step_list: EV_LIST
	compile_button, step_button, show_tree_button, show_source_button: EV_BUTTON
	disable_contracts_button: EV_CHECK_BUTTON
	log_area: EV_TEXT

	idle_color, work_color: EV_COLOR

	transformer: CODE_TRANSFORMER
	transformer_at_work: BOOLEAN

feature {NONE} -- GUI

	project_settings: PROJECT_SETTINGS

	make (a_project_settings: PROJECT_SETTINGS)
		do
			project_settings := a_project_settings
			default_create
		end

	initialize
		local
			file_box: EV_HORIZONTAL_BOX
			file_box_labels, file_box_texts, file_box_buttons: EV_VERTICAL_BOX
			compile_button_box: EV_HORIZONTAL_BOX
			compile_split_box: EV_VERTICAL_BOX
			log_split_box: EV_VERTICAL_BOX
			split_area: EV_VERTICAL_SPLIT_AREA
			main_box: EV_VERTICAL_BOX
--			es_dialog: EV_INFORMATION_DIALOG
		do
			Precursor {EV_TITLED_WINDOW}

			create idle_color.make_with_8_bit_rgb (255, 255, 255)
			create work_color.make_with_8_bit_rgb (240, 200, 200)

			create file_box
			file_box.set_padding (3)
			create file_box_labels
			file_box_labels.set_padding (3)
			file_box_labels.extend (create {EV_LABEL}.make_with_text ("CIL File:"))
			file_box_labels.extend (create {EV_LABEL}.make_with_text ("Output Directory:"))
			file_box_labels.extend (create {EV_LABEL}.make_with_text ("Required Libraries:"))
			file_box_labels.extend (create {EV_LABEL}.make_with_text ("Required Include Dirs:"))
			file_box.extend (file_box_labels)
			file_box.disable_item_expand (file_box.i_th (file_box.count))
			create file_box_texts
			file_box_texts.set_padding (3)
			create file_field
			file_field.disable_edit
			file_box_texts.extend (file_field)
			create dir_field
			dir_field.disable_edit
			file_box_texts.extend (dir_field)
			create libraries_field
			file_box_texts.extend (libraries_field)
			create include_dirs_field
			file_box_texts.extend (include_dirs_field)
			file_box.extend (file_box_texts)
			create file_box_buttons
			file_box_buttons.set_padding (3)
			create fileopen_button.make_with_text_and_action ("Open", agent fileopen_clicked)
			file_box_buttons.extend (fileopen_button)
			file_box_buttons.disable_item_expand (file_box_buttons.i_th (file_box_buttons.count))
			create diropen_button.make_with_text_and_action ("Open", agent diropen_clicked)
			file_box_buttons.extend (diropen_button)
			file_box_buttons.disable_item_expand (file_box_buttons.i_th (file_box_buttons.count))
			file_box.extend (file_box_buttons)
			file_box.disable_item_expand (file_box.i_th (file_box.count))

			create disable_oo_structs_button.make_with_text ("Disable O-O structs/unions")
			create disable_oo_reengineering_button.make_with_text ("Disable O-O Reengineering")
			create disable_bounds_checking_button.make_with_text ("Disable pointer/array bounds checking")

			create compile_button_box
			compile_button_box.set_padding (3)
			compile_button_box.extend (create {EV_HORIZONTAL_BOX}) -- spacer to have the buttons centered
			create compile_button.make_with_text_and_action ("Compile", agent compile_button_clicked)
			compile_button.disable_sensitive
			compile_button_box.extend (compile_button)
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			create step_button.make_with_text_and_action ("Step", agent step_button_clicked)
			step_button.disable_sensitive
			compile_button_box.extend (step_button)
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			compile_button_box.extend (create {EV_VERTICAL_SEPARATOR})
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			create show_tree_button.make_with_text_and_action ("Show Tree", agent show_tree_button_clicked)
			show_tree_button.disable_sensitive
			compile_button_box.extend (show_tree_button)
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			create show_source_button.make_with_text_and_action ("Show Source", agent show_source_button_clicked)
			show_source_button.disable_sensitive
			compile_button_box.extend (show_source_button)
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			compile_button_box.extend (create {EV_VERTICAL_SEPARATOR})
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			create disable_contracts_button.make_with_text ("Disable Contracts")
			disable_contracts_button.select_actions.extend (agent disable_contracts_button_clicked)
			compile_button_box.extend (disable_contracts_button)
			compile_button_box.disable_item_expand (compile_button_box.i_th (compile_button_box.count))
			compile_button_box.extend (create {EV_HORIZONTAL_BOX}) -- spacer to have the buttons centered

			create compile_split_box
			compile_split_box.set_padding (3)
			compile_split_box.extend (create {EV_LABEL}.make_with_text ("Steps:"))
			compile_split_box.disable_item_expand (compile_split_box.i_th (compile_split_box.count))
			create step_list
			step_list.select_actions.extend (agent update_step_button_sensitivity)
			step_list.deselect_actions.extend (agent update_step_button_sensitivity)
			compile_split_box.extend (step_list)
			compile_split_box.extend (compile_button_box)
			compile_split_box.disable_item_expand (compile_split_box.i_th (compile_split_box.count))
			compile_split_box.extend (create {EV_HORIZONTAL_SEPARATOR})
			compile_split_box.disable_item_expand (compile_split_box.i_th (compile_split_box.count))

			create log_split_box
			log_split_box.set_padding (3)
			log_split_box.extend (create {EV_LABEL}.make_with_text ("Log:"))
			log_split_box.disable_item_expand (log_split_box.i_th (log_split_box.count))
			create log_area
			log_area.disable_edit
			log_area.set_background_color (idle_color)
			log_split_box.extend (log_area)

			create split_area
			split_area.extend (compile_split_box)
			split_area.extend (log_split_box)

			create main_box
			main_box.set_padding (3)
			main_box.extend (file_box)
			main_box.disable_item_expand (main_box.i_th (main_box.count))
			main_box.extend (disable_oo_structs_button)
			main_box.disable_item_expand (main_box.i_th (main_box.count))
			main_box.extend (disable_oo_reengineering_button)
			main_box.disable_item_expand (main_box.i_th (main_box.count))
			main_box.extend (create {EV_HORIZONTAL_SEPARATOR})
			main_box.disable_item_expand (main_box.i_th (main_box.count))
			main_box.extend (disable_bounds_checking_button)
			main_box.disable_item_expand (main_box.i_th (main_box.count))
			main_box.extend (create {EV_HORIZONTAL_SEPARATOR})
			main_box.disable_item_expand (main_box.i_th (main_box.count))
			main_box.extend (split_area)

			extend (main_box)
			close_request_actions.extend (agent close_clicked)
			set_title ("C2Eif v0.4")
			set_size (1024, 768)

			-- cil_file, out_dir, libs, include_dirs, es_tmp_file
			if project_settings.cil_file /= Void then
				file_field.set_text (project_settings.cil_file.name)
			end
			if project_settings.output_dir /= Void then
				dir_field.set_text (project_settings.output_dir.name)
			end
			across project_settings.libraries as c loop
				if c.target_index > 1 then
					libraries_field.append_text ("; ")
				end
				libraries_field.append_text (c.item)
			end
			across project_settings.include_dirs as c loop
				if c.target_index > 1 then
					include_dirs_field.append_text ("; ")
				end
				include_dirs_field.append_text (c.item)
			end
			if project_settings.disable_oo_structs then
				disable_oo_structs_button.toggle
			end
			if project_settings.disable_oo_reengineering then
				disable_oo_reengineering_button.toggle
			end
			if project_settings.disable_bounds_checking then
				disable_bounds_checking_button.toggle
			end
			update_transformer

			-- configure `VIEW_INTERFACE'
			impl_log.log := agent (o: ANY)
					do
						if o /= Void then
							log_area.append_text (o.out)
							log_area.append_text ("%N")
						else
							log_area.append_text ("Void%N")
						end
						(create {EV_ENVIRONMENT}).application.process_events
					end

			show
			split_area.set_split_position (150)

--			if es_tmp_file /= Void then
--				create es_dialog.make_with_text ("Welcome to the C to Eiffel compiler!%NPlease visit http://c2eiffel.origo.ethz.ch for manuals, tutorials, program updates and much more.")
--				es_dialog.set_title ("C2Eiffel")
--				es_dialog.show_modal_to_window (Current)
--			end
		end

	close_clicked
		local
--			f: PLAIN_TEXT_FILE
		do
			if not transformer_at_work then
				destroy;
				(create {EV_ENVIRONMENT}).application.destroy

--				if es_tmp_file /= Void then
--					create f.make_open_write (es_tmp_file)
--					if transformer /= Void and then transformer.current_step_index = transformer.steps.count then
--						f.put_string ("Success=%"yes%"%N")
--						f.put_string ("Ace=%"" + transformer.output_dir + "/" +
--							(create {NAME_UTILITIES}).eiffel_class_name (transformer.tree.source_file_name).as_lower +
--							".ecf%"%N")
--						f.put_string ("Directory=%"" + transformer.output_dir + "%"%N")
--						f.put_string ("Compilation=%"yes%"%N")
--						f.put_string ("Compilation_type=%"melt%"%N")
--					else
--						f.put_string ("Success=%"no%"%N")
--					end
--					f.flush
--					f.close
--				end
			end
		end

	fileopen_clicked
		local
			dialog: EV_FILE_OPEN_DIALOG
		do
			create dialog.make_with_title ("Select C Source File")
			dialog.show_modal_to_window (Current)
			if not dialog.file_name.is_empty and not dialog.file_name.is_equal (file_field.text) then
				file_field.set_text (dialog.file_name)
				update_transformer
			end
		end

	diropen_clicked
		local
			dialog: EV_DIRECTORY_DIALOG
		do
			create dialog.make_with_title ("Select Output Directory")
			dialog.show_modal_to_window (Current)
			if not dialog.directory.is_empty and not dialog.directory.is_equal (dir_field.text) then
				dir_field.set_text (dialog.directory)
				update_transformer
			end
		end

	compile_button_clicked
		do
			compile_until (transformer.steps.count)
		end

	step_button_clicked
		do
			compile_until (step_list.index_of (step_list.selected_item, 1))
		end

	disable_contracts_button_clicked
		do
			{ISE_RUNTIME}.check_assert (not disable_contracts_button.is_selected).do_nothing
		end

	show_tree_button_clicked
		local
			ast_viewer: AST_VIEWER
		do
			create ast_viewer.make
			transformer.emit_tree (ast_viewer.tree)
			ast_viewer.show
		end

	show_source_button_clicked
		local
			source_viewer: SOURCE_VIEWER
		do
			create source_viewer.make
			transformer.emit_source (source_viewer.source_code)
			source_viewer.show
		end

feature {NONE} -- implementation

	update_step_button_sensitivity
		do
			if transformer_at_work or step_list.selected_item = Void then
				step_button.disable_sensitive
			else
				step_button.enable_sensitive
			end
		end

	compile_until (i: INTEGER)
		local
			ok: BOOLEAN
		do
			across libraries_field.text.split (';') as c loop
				c.item.left_adjust
				c.item.right_adjust
				if not c.item.is_empty then
					transformer.project_settings.libraries.extend (c.item)
				end
			end
			across include_dirs_field.text.split (';') as c loop
				c.item.left_adjust
				c.item.right_adjust
				if not c.item.is_empty then
					transformer.project_settings.include_dirs.extend (c.item)
				end
			end
			transformer.project_settings.disable_oo_structs := disable_oo_structs_button.is_selected
			transformer.project_settings.disable_oo_reengineering := disable_oo_reengineering_button.is_selected
			transformer.project_settings.disable_bounds_checking := disable_bounds_checking_button.is_selected

			transformer_at_work := True
			fileopen_button.disable_sensitive
			diropen_button.disable_sensitive
			libraries_field.disable_sensitive
			libraries_field.set_background_color (work_color)
			include_dirs_field.disable_sensitive
			include_dirs_field.set_background_color (work_color)
			disable_oo_structs_button.disable_sensitive
			disable_oo_reengineering_button.disable_sensitive
			disable_bounds_checking_button.disable_sensitive
			step_list.set_focus
			step_list.set_background_color (work_color)
			compile_button.disable_sensitive
			step_button.disable_sensitive
			show_tree_button.disable_sensitive
			show_source_button.disable_sensitive
			log_area.set_background_color (work_color)

			ok := transformer.go (i)

			transformer_at_work := False
			fileopen_button.enable_sensitive
			diropen_button.enable_sensitive
			libraries_field.enable_sensitive
			libraries_field.set_background_color (idle_color)
			include_dirs_field.enable_sensitive
			include_dirs_field.set_background_color (idle_color)
			disable_oo_structs_button.enable_sensitive
			disable_oo_reengineering_button.enable_sensitive
			disable_bounds_checking_button.enable_sensitive
			step_list.set_background_color (idle_color)
			compile_button.enable_sensitive
			update_step_button_sensitivity
			if ok then
				show_tree_button.enable_sensitive
				show_source_button.enable_sensitive
			end
			log_area.set_background_color (idle_color)
		end

	update_transformer
		local
			l_project_settings: PROJECT_SETTINGS
			l_i: INTEGER
		do
			if not file_field.text.is_empty and not dir_field.text.is_empty then
				create l_project_settings
				l_project_settings.cil_file := create {RAW_FILE}.make (file_field.text)
				l_project_settings.output_dir := create {DIRECTORY}.make (dir_field.text)

				create transformer.make (l_project_settings)
				transformer.progress_listener.extend (agent update_transformer_progress)
				from
					step_list.wipe_out
					l_i := 1
				until
					l_i > transformer.steps.count
				loop
					step_list.extend (create {EV_LIST_ITEM}.make_with_text (l_i.out + ". " + transformer.steps.item (l_i).description))
					l_i := l_i + 1
				end
				compile_button.enable_sensitive
				step_button.disable_sensitive
				show_tree_button.disable_sensitive
				show_source_button.disable_sensitive
				log_area.set_text ("")
			end
		end

	update_transformer_progress (step_num: INTEGER)
		local
			i: INTEGER
		do
			if step_num = 1 then
				log_area.set_text ("")
			end
			from
				i := 1
			until
				i > step_list.count
			loop
				if i = step_num then
					step_list.i_th (i).set_text ("-> " + i.out + ". " + transformer.steps[i].description)
					step_list.i_th (i).enable_select
					step_list.ensure_item_visible (step_list.i_th (i))
				else
					step_list.i_th (i).set_text (i.out + ". " + transformer.steps[i].description)
				end
				i := i + 1
			end
			(create {EV_ENVIRONMENT}).application.process_events
		end

end
