class
	CALL_GRAPH_VIEWER

inherit
	DOT_VIEWER

create
	make

feature {NONE}

	make (a_nodes: HASH_SET [AST_STRUCT_DECLARATION])
		do
			nodes := a_nodes
		end

	nodes: HASH_SET [AST_STRUCT_DECLARATION]

	write_dot_file (a_file: PLAIN_TEXT_FILE)
		local
			l_i: NATURAL_32
		do
			a_file.put_string ("digraph g {%N")
			a_file.put_string ("labelloc=%"t%"%N")
			a_file.put_string ("label=%"Call Graph%"%N")
			a_file.put_string ("node [shape=box]%N")
			across nodes as class_cursor loop
				l_i := l_i + 1
				a_file.put_string ("%N")
				a_file.put_string ("subgraph cluster" + l_i.out +" {%N")
				a_file.put_string ("	label=%"" + class_cursor.item.identifier + "%"%N")
				if class_cursor.item.oo_features.is_empty and class_cursor.item.oo_static_features.is_empty then
					-- add a dummy so the class is shown
					a_file.put_string ("	dummy" + l_i.out + " [label=%"%", height=0, style=invisible]%N")
				else
					across class_cursor.item.oo_features as feature_cursor loop
						a_file.put_string ("	" + feature_cursor.item.identifier + " [label=%"" + feature_cursor.item.identifier + " (M)%"]%N")
					end
					across class_cursor.item.oo_static_features as feature_cursor loop
						a_file.put_string ("	" + feature_cursor.item.identifier + " [label=%"" + feature_cursor.item.identifier + " (S)%"]%N")
					end
				end
				a_file.put_string ("}%N")
				across class_cursor.item.oo_features as feature_cursor loop
					across feature_cursor.item.call_graph.out_calls as out_call_cursor loop
						a_file.put_string (feature_cursor.item.identifier + " -> " + out_call_cursor.item.ast_feature.identifier + "%N")
					end
				end
				across class_cursor.item.oo_static_features as feature_cursor loop
					across feature_cursor.item.call_graph.out_calls as out_call_cursor loop
						a_file.put_string (feature_cursor.item.identifier + " -> " + out_call_cursor.item.ast_feature.identifier + "%N")
					end
				end
			end
			a_file.put_string ("}%N")
		end

end
