class
	CFG_VIEWER

inherit
	DOT_VIEWER

create
	make

feature {NONE}

	make (a_node: AST_FUNCTION_DECLARATION)
		do
			node := a_node
		end

	node: AST_FUNCTION_DECLARATION

	write_dot_file (a_file: PLAIN_TEXT_FILE)
		local
			l_s: HASH_SET [CFG_BASIC_BLOCK]
			l_l: TWO_WAY_LIST [CFG_BASIC_BLOCK]
			l_c_code: STRING_8
		do
			a_file.put_string ("digraph g {%N")
			a_file.put_string ("labelloc=%"t%"%N")
			a_file.put_string ("label=%"" + node.identifier + "%"%N")
			a_file.put_string ("node [shape=box]%N")

			from
				create l_l.make
				create l_s.make (16)
				l_l.extend (node.cfg)
				l_s.extend (node.cfg)
				l_l.start
			until
				l_l.after
			loop
				-- node
				a_file.put_string ("bb" + l_l.item.hash_code.out + " [label=%"")
				across l_l.item.nodes as c loop
					l_c_code := c.item.c_code
					l_c_code.replace_substring_all ("\", "\\")
					l_c_code.replace_substring_all ("%"", "\%"")
					a_file.put_string (l_c_code)
					a_file.put_string ("\l")
				end
				a_file.put_string ("%"]%N")

				-- edges
				across l_l.item.out_edges as c loop
					a_file.put_string ("bb" + l_l.item.hash_code.out + " -> bb" + c.item.to_block.hash_code.out)
					inspect c.item.label
					when {CFG_EDGE}.Label_no_label then -- nothing to do
					when {CFG_EDGE}.Label_true     then a_file.put_string (" [label=%"True%"]")
					when {CFG_EDGE}.Label_false    then a_file.put_string (" [label=%"False%"]")
					end
					a_file.put_string ("%N")
				end

				across l_l.item.out_edges as c loop
					if not l_s.has (c.item.to_block) then
						l_l.extend (c.item.to_block)
						l_s.extend (c.item.to_block)
					end
				end
				l_l.forth
			end

			a_file.put_string ("}%N")
		end

end
